#include winim/[inc\shellapi, winstr]
include winim/[inc\shellapi]
import winim/winstr
import nimbass/bass
import os
#import wNim
import wNim/[wFileDialog]
import strutils
import strformat
import typetraits
import ../../nim/[inc\Ternary]

# Todo: Hotkeys for Volume, Prev/Next Song, ...
# Todo: walkDirRec

#let currentEncoding = getCurrentEncoding()

#[ type
  ConditionPair[T] = object
    ifTrue, ifFalse: T

proc `!`*[T](a, b: T): ConditionPair[T] {.inline.} = ConditionPair[T](ifTrue: a, ifFalse: b)

template `?`*[T](cond: bool; p: ConditionPair[T]): T =
  (if cond: p.ifTrue else: p.ifFalse)
 ]#
# Die BASS-dll ist in C geschrieben, deswegen die C-Variablen
var
  iLen: bass.QWORD
  iSeconds, iSecondsNow: cdouble
  fBitrate, fVolume: cfloat
  bVolume: bool = true
  hChannel: HSTREAM
  flags: bass.DWORD = bass.DWORD(BASS_STREAM_PRESCAN or BASS_STREAM_AUTOFREE or BASS_UNICODE)
  sPlaytime: string

fVolume = 0.5

type
  tExt = array[8, string]
let aExt: tExt = [".mp3", ".m4a", ".flac", ".wav", ".wma", ".aif", ".ac3", ".mp2"]
  # ".ogg" usw. nur mit add-on: https://www.un4seen.com/
var audioWildcards: string = "Audio files|" # für FileDialog
for i in low(aExt)..high(aExt):
  audioWildcards &= "*" & aExt[i] & (i == high(aExt) ? "" ! ";")
echo "audioWildcards = " & audioWildcards

proc checkExt(s: string): bool =
  var e = splitFile(s).ext
  #echo "checkExt s = " & $type(s) & " " & s
  #echo "checkExt e = " & $type(e) & " " & e
  for i in low(aExt)..high(aExt):
    if aExt[i] == e:
      return true
  return false

proc fmtPlaytime(): void =
  case ($int(iSeconds)).len:
  of 5:
    sPlaytime = fmt"{$int(iSecondsNow):>5}" & " / " & fmt"{$int (iSeconds):>5}"
  of 4:
    sPlaytime = fmt"{$int(iSecondsNow):>4}" & " / " & fmt"{$int (iSeconds):>4}"
  of 3:
    sPlaytime = fmt"{$int(iSecondsNow):>3}" & " / " & fmt"{$int (iSeconds):>3}"
  else:
    sPlaytime = fmt"{$int(iSecondsNow):>2}" & " / " & fmt"{$int (iSeconds):>2}"

proc playfile(sMp3File: string): bool =
  var pMp3File: LPCWSTR = sMp3File
  
  echo "\nPlaying           : " & sMp3File

  # Audiogerät initialisieren
  discard BASS_Init(cint(-1), cast[bass.DWORD](44100), cast[bass.DWORD](0), cast[bass.DWORD](0), nil)

  # Gesamtlautstärke ändern (0.0 - 1.0)
  #if bVolume: discard BASS_SetVolume(fVolume)

  # BASS_StreamCreateFile erwartet einen Pointer auf den Dateinamen
  # MP3-File als Stream in den Speicher laden (wird am Ende automatisch freigegeben)
  # hChannel = BASS_StreamCreateFile(false, pMp3File, 0, 0, flags)
  hChannel = BASS_StreamCreateFile(FALSE, pMp3File, 0, 0, flags)
  echo "hChannel          : 0x" & toHex($hChannel)
  if hChannel == 0:
    echo "BASS_ErrorGetCode() = " & $BASS_ErrorGetCode()
    return false

  # Lautstärke (0.0 - 1.0) für den Stream setzen
  if bVolume:
    discard BASS_ChannelSetAttribute(hChannel, BASS_ATTRIB_VOL, fVolume)
    bVolume = false

  # Durchschnittliche Bitrate auslesen (Pointer auf fBitrate)
  # if BASS_ChannelGetAttribute(hChannel, BASS_ATTRIB_BITRATE, fBitrate.addr()):
  if BASS_ChannelGetAttribute(hChannel, BASS_ATTRIB_BITRATE, fBitrate.addr()) == TRUE:
    echo "Bitrate           : " & $int(fBitrate) & " kBit/s"

  # Lautstärke des Streams auslesen (Pointer auf fVolume)
  # if BASS_ChannelGetAttribute(hChannel, BASS_ATTRIB_VOL, fVolume.addr()):
  if BASS_ChannelGetAttribute(hChannel, BASS_ATTRIB_VOL, fVolume.addr()) == TRUE:
    echo "Volume            : " & fmt"{fVolume:<2.1f}"

  # Laufzeit des Streams auslesen (in Bytes)
  iLen = BASS_ChannelGetLength(hChannel, BASS_POS_BYTE)
  echo "Länge in Bytes    : " & $iLen

  # Laufzeit in Sekunden umrechnen
  iSeconds = BASS_ChannelBytes2Seconds(hChannel, iLen)
  echo "Länge in Sekunden : " & $int(iSeconds)

  # if BASS_ChannelPlay(hChannel, false):
  if BASS_ChannelPlay(hChannel, FALSE) == TRUE:
    while true:
      case BASS_ChannelIsActive(hChannel) # liefert ein DWORD zurück
      of BASS_ACTIVE_PLAYING:             # Player ist noch aktiv
        iLen = BASS_ChannelGetPosition(hChannel, BASS_POS_BYTE)
        iSecondsNow = BASS_ChannelBytes2Seconds(hChannel, iLen)
        #echo "Position: " & $int(iSecondsNow) & " / " & $int(iSeconds)
        #stdout.write "\rPlaytime: " & $int(iSecondsNow) & " / " & $int(iSeconds)
        fmtPlaytime()
        # "\r" puts the write cursor back at the beginning of the line
        stdout.write "\rPlaytime          : " & sPlaytime
        sleep(1000)                       # eine Sekunde warten 
      of BASS_ACTIVE_STOPPED: break       # Player Stop
      of BASS_ACTIVE_PAUSED: break        # Player Pause
      of BASS_ACTIVE_PAUSED_DEVICE: break # Device Pause
      of BASS_ACTIVE_STALLED: break       # Datenstrom unterbrochen
      else: break                         # While-Schleife verlassen
  discard BASS_ChannelStop(hChannel)
  discard BASS_Free()
  echo "\n"
  return true

var sPath:string

if paramCount() > 0:
  for p in 1..paramCount():
    var list = paramStr(p)
    if list[0..2] == "-v:": # Lautstärke 0.0 - 1.0
      fVolume = parseFloat(list[3..^1]) # strutils.parseFloat
      fVolume = parseFloat(fmt"{fVolume:<2.1f}")
      echo "===>>> " & $fVolume & " " & $type(fVolume)
      continue
    if list[0..2] == "-l:": # ? Listfile (from Total Commander) or M3U-Playlist
      if PathFileExistsW(list[3..^1]) != windef.TRUE:
        echo "Listfile not found!\n===>>> " & list[3..^1]
        quit(-1)
      else:
        var files = readFile(list[3..^1])
        if toHex(files[0..2]) == "EFBBBF": files = files[3..^1] # UTF-8 BOM entfernen
        if files[0..6] == "#EXTM3U": sPath = splitFile(list[3..^1]).dir & r"\"
        echo "sPath = " & sPath
        echo "files = " & $type(files) & "\n" & files # TaintedString
        for line in splitLines(files):
          if line == "": continue
          echo "line = " & $type(line) & " '" & line & "'"
          if PathIsDirectoryW(sPath & line) == FILE_ATTRIBUTE_DIRECTORY or
            splitFile(sPath & line).ext == "":
            echo "play from list dir"
            echo "walkFiles('" & sPath & line & r"\*.*')"
            for walk in walkFiles(sPath & line & r"\*.*"): # *.mp3
              echo "walk = " & $type(walk) & " " & walk
              if checkExt(walk):
                if not playfile(walk): # <<<================================== OK
                  echo "play from list dir failed!\n===>>> " & walk
                  quit(1)
          else:
            echo "play from list file " &
              (sPath == "" ? "(Total Commander)" ! "(M3U-Playlist)")
            echo "line = " & $type(line) & " '" & line & "'"
            if checkExt(sPath & line):
              if not playfile(sPath & line): # <<<============================ OK
                echo "play from list file failed!\n===>>> " & sPath & line
                quit(2)
    else:
      sPath = paramStr(p)
      if sPath[^1] == chr(34): # [^1] = [sPath.len-1]
        # ! Bad path, trim trailing quote
        sPath = sPath[0..^2] # [0..^2] = [0..sPath.len-2]
      if PathFileExistsW(sPath) != windef.TRUE:
        echo "File from paramStr(" & $p & ") not found!\n===>>> " & sPath
        quit(-1)
      if PathIsDirectoryW(sPath) == FILE_ATTRIBUTE_DIRECTORY or
          splitFile(sPath).ext == "":
#[
      # It works that way too, but is more cumbersome.
      try:
        var oFileInfo = getFileInfo(sPath)
        if $oFileInfo.kind == "pcDir":
          echo "getFileInfo(sPath): sPath is a directory!"
      except:
        echo "getFileInfo(sPath) failed!"
        
        # Iterate over all the directories that match the pattern.
        for kind, path in walkDir(sPath):
      
        # Iterate over all the files and directories that match the pattern.
        for path in walkPattern($sPath & "\\*.mp3"):

        #Recursively walks over the directory dir and yields for each file or directory in dir.
        #If relative is true (default: false) the resulting path is shortened to be relative to dir, otherwise the full path is returned.
        walkDirRec(dir: string; yieldFilter = {pcFile}; followFilter = {pcDir};
                   relative = false; checkDir = false): string {...}
]#

        echo "play from paramStr(" & $p & ") (dir)"
        # Iterate over all the files that match the pattern.
        for walk in walkFiles($sPath & "\\*.*"): # ? sPath is a directory
          if checkExt(walk):
            if not playfile(walk): # <<<==================================== OK
              echo "play from param dir failed!\n===>>> " & walk
              quit(3)
      else: # ? sPath is not a file
        #pMp3File = paramStr(p)
        echo "play from paramStr(" & $p & ") (file)"
        if checkExt(paramStr(p)):
          if not playfile(paramStr(p)): # <<<=============================== OK
            echo "play from param file failed!\n===>>> " & paramStr(p)
            quit(4)
else:
  echo "play from FileDialog"
  while true:
    var files = FileDialog(nil, "Select Audio Files",
      defaultDir = r"f:\Audio\MP3\International\",
      wildcard = audioWildcards, # "Audio files|*.mp3;*.m4a;..."
      style = wFdOpen or wFdFileMustExist or wFdMultiple).display()
    if files.len > 0:
      for k in 0..<files.len:
        if not playfile(files[k]): # <<<==================================== OK
          echo "play from FileDialog failed!\n===>>> " & files[k]
          quit(5)
    else:
      break
